#
# Build APEX_Legacy
#

SET(GW_DEPS_ROOT $ENV{GW_DEPS_ROOT})
FIND_PACKAGE(PxShared REQUIRED)

SET(APEX_MODULE_DIR ${PROJECT_SOURCE_DIR}/../../../module)

# These 4 are the only ones used in the Linux version
SET(CLOTHING_SOURCE_DIR ${APEX_MODULE_DIR}/clothing_legacy)
SET(COMMON_SOURCE_DIR ${APEX_MODULE_DIR}/common_legacy)
SET(DESTRUCTIBLE_SOURCE_DIR ${APEX_MODULE_DIR}/destructible_legacy)
SET(FRAMEWORK_SOURCE_DIR ${APEX_MODULE_DIR}/framework_legacy)

SET(BFS_SOURCE_DIR ${APEX_MODULE_DIR}/basicfs_legacy)
SET(BIOS_SOURCE_DIR ${APEX_MODULE_DIR}/basicios_legacy)
SET(EMITTER_SOURCE_DIR ${APEX_MODULE_DIR}/emitter_legacy)
SET(FORCEFIELD_SOURCE_DIR ${APEX_MODULE_DIR}/forcefield_legacy)
SET(IOFX_SOURCE_DIR ${APEX_MODULE_DIR}/iofx_legacy)
SET(PARTICLES_SOURCE_DIR ${APEX_MODULE_DIR}/particles_legacy)
SET(PXPARTICLEIOS_SOURCE_DIR ${APEX_MODULE_DIR}/pxparticleios_legacy)
SET(TURBFS_SOURCE_DIR ${APEX_MODULE_DIR}/turbulencefs_legacy)

SET(LEGACY_SOURCE_DIR ${APEX_MODULE_DIR}/legacy)

SET(APEX_LEGACY_LIBTYPE STATIC)

SET(APEX_LEGACY_PLATFORM_INCLUDES
	${PHYSX_ROOT_DIR}/Source/PhysXGpu/include
)

# Use generator expressions to set config specific preprocessor definitions
SET(APEX_LEGACY_COMPILE_DEFS 
	# Common to all configurations
	${APEX_LINUX_COMPILE_DEFS};_LIB;PX_PHYSX_STATIC_LIB;
)

if(${CMAKE_BUILD_TYPE_LOWERCASE} STREQUAL "debug")
	LIST(APPEND APEX_LEGACY_COMPILE_DEFS 
		${APEX_LINUX_DEBUG_COMPILE_DEFS};PX_PHYSX_DLL_NAME_POSTFIX=DEBUG;
	)
elseif(${CMAKE_BUILD_TYPE_LOWERCASE} STREQUAL "checked")
	LIST(APPEND APEX_LEGACY_COMPILE_DEFS 
		${APEX_LINUX_CHECKED_COMPILE_DEFS};PX_PHYSX_DLL_NAME_POSTFIX=CHECKED;
	)
elseif(${CMAKE_BUILD_TYPE_LOWERCASE} STREQUAL "profile")
	LIST(APPEND APEX_LEGACY_COMPILE_DEFS 
		${APEX_LINUX_PROFILE_COMPILE_DEFS};PX_PHYSX_DLL_NAME_POSTFIX=PROFILE;
	)
elseif(${CMAKE_BUILD_TYPE_LOWERCASE} STREQUAL release)
	LIST(APPEND APEX_LEGACY_COMPILE_DEFS 
		${APEX_LINUX_RELEASE_COMPILE_DEFS}
	)
else(${CMAKE_BUILD_TYPE_LOWERCASE} STREQUAL "debug")
	MESSAGE(FATAL_ERROR "Unknown configuration ${CMAKE_BUILD_TYPE}")
endif(${CMAKE_BUILD_TYPE_LOWERCASE} STREQUAL "debug")


# include common ApexLegacy.cmake
INCLUDE(../common/ApexLegacy.cmake)

# enable -fPIC so we can link static libs with the editor
SET_TARGET_PROPERTIES(APEX_Legacy PROPERTIES POSITION_INDEPENDENT_CODE TRUE)
