#
# Build APEX_Loader
#

SET(GW_DEPS_ROOT $ENV{GW_DEPS_ROOT})
FIND_PACKAGE(PxShared REQUIRED)

SET(APEX_MODULE_DIR ${PROJECT_SOURCE_DIR}/../../../module)

SET(AM_SOURCE_DIR ${APEX_MODULE_DIR}/loader)

SET(APEX_LOADER_LIBTYPE STATIC)


# Use generator expressions to set config specific preprocessor definitions
SET(APEX_LOADER_COMPILE_DEFS 
	# Common to all configurations
	${APEX_LINUX_COMPILE_DEFS};_LIB;PX_PHYSX_STATIC_LIB;
	__Linux__;Linux;NX_USE_SDK_STATICLIBS;NX_FOUNDATION_STATICLIB;NV_PARAMETERIZED_HIDE_DESCRIPTIONS=1;_LIB;ENABLE_TEST=0;
)

if(${CMAKE_BUILD_TYPE_LOWERCASE} STREQUAL "debug")
	LIST(APPEND APEX_LOADER_COMPILE_DEFS 
		${APEX_LINUX_DEBUG_COMPILE_DEFS};PX_PHYSX_DLL_NAME_POSTFIX=DEBUG;
	)
elseif(${CMAKE_BUILD_TYPE_LOWERCASE} STREQUAL "checked")
	LIST(APPEND APEX_LOADER_COMPILE_DEFS 
		${APEX_LINUX_CHECKED_COMPILE_DEFS};PX_PHYSX_DLL_NAME_POSTFIX=CHECKED;
	)
elseif(${CMAKE_BUILD_TYPE_LOWERCASE} STREQUAL "profile")
	LIST(APPEND APEX_LOADER_COMPILE_DEFS 
		${APEX_LINUX_PROFILE_COMPILE_DEFS};PX_PHYSX_DLL_NAME_POSTFIX=PROFILE;
	)
elseif(${CMAKE_BUILD_TYPE_LOWERCASE} STREQUAL release)
	LIST(APPEND APEX_LOADER_COMPILE_DEFS 
		${APEX_LINUX_RELEASE_COMPILE_DEFS}
	)
else(${CMAKE_BUILD_TYPE_LOWERCASE} STREQUAL "debug")
	MESSAGE(FATAL_ERROR "Unknown configuration ${CMAKE_BUILD_TYPE}")
endif(${CMAKE_BUILD_TYPE_LOWERCASE} STREQUAL "debug")


# include common ApexLoader.cmake
INCLUDE(../common/ApexLoader.cmake)

# Do final direct sets after the target has been defined
TARGET_LINK_LIBRARIES(APEX_Loader PUBLIC
	APEX_Clothing APEX_Destructible APEX_Legacy ApexCommon ApexFramework NvParameterized PsFastXml PxFoundation PxPvdSDK
#		PhysXCommon - does it really need this?
)

# enable -fPIC so we can link static libs with the editor
SET_TARGET_PROPERTIES(APEX_Loader PROPERTIES POSITION_INDEPENDENT_CODE TRUE)
