// This code contains NVIDIA Confidential Information and is disclosed to you
// under a form of NVIDIA software license agreement provided separately to you.
//
// Notice
// NVIDIA Corporation and its licensors retain all intellectual property and
// proprietary rights in and to this software and related documentation and
// any modifications thereto. Any use, reproduction, disclosure, or
// distribution of this software and related documentation without an express
// license agreement from NVIDIA Corporation is strictly prohibited.
//
// ALL NVIDIA DESIGN SPECIFICATIONS, CODE ARE PROVIDED "AS IS.". NVIDIA MAKES
// NO WARRANTIES, EXPRESSED, IMPLIED, STATUTORY, OR OTHERWISE WITH RESPECT TO
// THE MATERIALS, AND EXPRESSLY DISCLAIMS ALL IMPLIED WARRANTIES OF NONINFRINGEMENT,
// MERCHANTABILITY, AND FITNESS FOR A PARTICULAR PURPOSE.
//
// Information and code furnished is believed to be accurate and reliable.
// However, NVIDIA Corporation assumes no responsibility for the consequences of use of such
// information or for any infringement of patents or other rights of third parties that may
// result from its use. No license is granted by implication or otherwise under any patent
// or patent rights of NVIDIA Corporation. Details are subject to change without notice.
// This code supersedes and replaces all information previously supplied.
// NVIDIA Corporation products are not authorized for use as critical
// components in life support devices or systems without express written approval of
// NVIDIA Corporation.
//
// Copyright (c) 2008-2015 NVIDIA Corporation. All rights reserved.

// This file was generated by NvParameterized/scripts/GenParameterized.pl


#ifndef HEADER_ClothingDebugRenderParams_h
#define HEADER_ClothingDebugRenderParams_h

#include "NvParametersTypes.h"

#ifndef NV_PARAMETERIZED_ONLY_LAYOUTS
#include "nvparameterized/NvParameterized.h"
#include "nvparameterized/NvParameterizedTraits.h"
#include "NvParameters.h"
#include "NvTraitsInternal.h"
#endif

namespace nvidia
{
namespace clothing
{

#if PX_VC
#pragma warning(push)
#pragma warning(disable: 4324) // structure was padded due to __declspec(align())
#endif

namespace ClothingDebugRenderParamsNS
{



struct ParametersStruct
{

	bool Actors;
	float SkinnedPositions;
	bool Backstop;
	float BackstopPrecise;
	bool MaxDistance;
	bool MaxDistanceInwards;
	bool SkinMapAll;
	bool SkinMapBad;
	bool SkinMapActual;
	bool SkinMapInvalidBary;
	float PhysicsMeshWire;
	float PhysicsMeshSolid;
	float PhysicsMeshNormals;
	bool Skeleton;
	float BoneFrames;
	float BoneNames;
	float Velocities;
	float Wind;
	bool GraphicalVertexBones;
	bool PhysicalVertexBones;
	bool CollisionShapes;
	bool CollisionShapesWire;
	bool LengthFibers;
	bool CrossSectionFibers;
	bool BendingFibers;
	bool ShearingFibers;
	bool ZerostretchFibers;
	bool TethersActive;
	bool TethersInactive;
	bool VirtualCollision;
	bool FiberRange;
	bool ShowInLocalSpace;
	bool GlobalPose;
	bool RecomputeSubmeshes;
	bool RecomputeVertices;
	bool PhysicsMeshIndices;
	bool MassScale;
	bool SelfCollision;
	bool SelfCollisionWire;
	float SelfCollisionAttenuation;
	bool SolverMode;

};

static const uint32_t checksum[] = { 0x0814367c, 0x9b811470, 0x122fd821, 0xd5717b8e, };

} // namespace ClothingDebugRenderParamsNS

#ifndef NV_PARAMETERIZED_ONLY_LAYOUTS
class ClothingDebugRenderParams : public NvParameterized::NvParameters, public ClothingDebugRenderParamsNS::ParametersStruct
{
public:
	ClothingDebugRenderParams(NvParameterized::Traits* traits, void* buf = 0, int32_t* refCount = 0);

	virtual ~ClothingDebugRenderParams();

	virtual void destroy();

	static const char* staticClassName(void)
	{
		return("ClothingDebugRenderParams");
	}

	const char* className(void) const
	{
		return(staticClassName());
	}

	static const uint32_t ClassVersion = ((uint32_t)0 << 16) + (uint32_t)0;

	static uint32_t staticVersion(void)
	{
		return ClassVersion;
	}

	uint32_t version(void) const
	{
		return(staticVersion());
	}

	static const uint32_t ClassAlignment = 8;

	static const uint32_t* staticChecksum(uint32_t& bits)
	{
		bits = 8 * sizeof(ClothingDebugRenderParamsNS::checksum);
		return ClothingDebugRenderParamsNS::checksum;
	}

	static void freeParameterDefinitionTable(NvParameterized::Traits* traits);

	const uint32_t* checksum(uint32_t& bits) const
	{
		return staticChecksum(bits);
	}

	const ClothingDebugRenderParamsNS::ParametersStruct& parameters(void) const
	{
		ClothingDebugRenderParams* tmpThis = const_cast<ClothingDebugRenderParams*>(this);
		return *(static_cast<ClothingDebugRenderParamsNS::ParametersStruct*>(tmpThis));
	}

	ClothingDebugRenderParamsNS::ParametersStruct& parameters(void)
	{
		return *(static_cast<ClothingDebugRenderParamsNS::ParametersStruct*>(this));
	}

	virtual NvParameterized::ErrorType getParameterHandle(const char* long_name, NvParameterized::Handle& handle) const;
	virtual NvParameterized::ErrorType getParameterHandle(const char* long_name, NvParameterized::Handle& handle);

	void initDefaults(void);

protected:

	virtual const NvParameterized::DefinitionImpl* getParameterDefinitionTree(void);
	virtual const NvParameterized::DefinitionImpl* getParameterDefinitionTree(void) const;


	virtual void getVarPtr(const NvParameterized::Handle& handle, void*& ptr, size_t& offset) const;

private:

	void buildTree(void);
	void initDynamicArrays(void);
	void initStrings(void);
	void initReferences(void);
	void freeDynamicArrays(void);
	void freeStrings(void);
	void freeReferences(void);

	static bool mBuiltFlag;
	static NvParameterized::MutexType mBuiltFlagMutex;
};

class ClothingDebugRenderParamsFactory : public NvParameterized::Factory
{
	static const char* const vptr;

public:

	virtual void freeParameterDefinitionTable(NvParameterized::Traits* traits)
	{
		ClothingDebugRenderParams::freeParameterDefinitionTable(traits);
	}

	virtual NvParameterized::Interface* create(NvParameterized::Traits* paramTraits)
	{
		// placement new on this class using mParameterizedTraits

		void* newPtr = paramTraits->alloc(sizeof(ClothingDebugRenderParams), ClothingDebugRenderParams::ClassAlignment);
		if (!NvParameterized::IsAligned(newPtr, ClothingDebugRenderParams::ClassAlignment))
		{
			NV_PARAM_TRAITS_WARNING(paramTraits, "Unaligned memory allocation for class ClothingDebugRenderParams");
			paramTraits->free(newPtr);
			return 0;
		}

		memset(newPtr, 0, sizeof(ClothingDebugRenderParams)); // always initialize memory allocated to zero for default values
		return NV_PARAM_PLACEMENT_NEW(newPtr, ClothingDebugRenderParams)(paramTraits);
	}

	virtual NvParameterized::Interface* finish(NvParameterized::Traits* paramTraits, void* bufObj, void* bufStart, int32_t* refCount)
	{
		if (!NvParameterized::IsAligned(bufObj, ClothingDebugRenderParams::ClassAlignment)
		        || !NvParameterized::IsAligned(bufStart, ClothingDebugRenderParams::ClassAlignment))
		{
			NV_PARAM_TRAITS_WARNING(paramTraits, "Unaligned memory allocation for class ClothingDebugRenderParams");
			return 0;
		}

		// Init NvParameters-part
		// We used to call empty constructor of ClothingDebugRenderParams here
		// but it may call default constructors of members and spoil the data
		NV_PARAM_PLACEMENT_NEW(bufObj, NvParameterized::NvParameters)(paramTraits, bufStart, refCount);

		// Init vtable (everything else is already initialized)
		*(const char**)bufObj = vptr;

		return (ClothingDebugRenderParams*)bufObj;
	}

	virtual const char* getClassName()
	{
		return (ClothingDebugRenderParams::staticClassName());
	}

	virtual uint32_t getVersion()
	{
		return (ClothingDebugRenderParams::staticVersion());
	}

	virtual uint32_t getAlignment()
	{
		return (ClothingDebugRenderParams::ClassAlignment);
	}

	virtual const uint32_t* getChecksum(uint32_t& bits)
	{
		return (ClothingDebugRenderParams::staticChecksum(bits));
	}
};
#endif // NV_PARAMETERIZED_ONLY_LAYOUTS

} // namespace clothing
} // namespace nvidia

#if PX_VC
#pragma warning(pop)
#endif

#endif
