// This code contains NVIDIA Confidential Information and is disclosed to you
// under a form of NVIDIA software license agreement provided separately to you.
//
// Notice
// NVIDIA Corporation and its licensors retain all intellectual property and
// proprietary rights in and to this software and related documentation and
// any modifications thereto. Any use, reproduction, disclosure, or
// distribution of this software and related documentation without an express
// license agreement from NVIDIA Corporation is strictly prohibited.
//
// ALL NVIDIA DESIGN SPECIFICATIONS, CODE ARE PROVIDED "AS IS.". NVIDIA MAKES
// NO WARRANTIES, EXPRESSED, IMPLIED, STATUTORY, OR OTHERWISE WITH RESPECT TO
// THE MATERIALS, AND EXPRESSLY DISCLAIMS ALL IMPLIED WARRANTIES OF NONINFRINGEMENT,
// MERCHANTABILITY, AND FITNESS FOR A PARTICULAR PURPOSE.
//
// Information and code furnished is believed to be accurate and reliable.
// However, NVIDIA Corporation assumes no responsibility for the consequences of use of such
// information or for any infringement of patents or other rights of third parties that may
// result from its use. No license is granted by implication or otherwise under any patent
// or patent rights of NVIDIA Corporation. Details are subject to change without notice.
// This code supersedes and replaces all information previously supplied.
// NVIDIA Corporation products are not authorized for use as critical
// components in life support devices or systems without express written approval of
// NVIDIA Corporation.
//
// Copyright (c) 2008-2016 NVIDIA Corporation. All rights reserved.
// Copyright (c) 2004-2008 AGEIA Technologies, Inc. All rights reserved.
// Copyright (c) 2001-2004 NovodeX AG. All rights reserved.  

#ifndef GU_TRIANGLE_VERTEX_POINTERS_H
#define GU_TRIANGLE_VERTEX_POINTERS_H

#include "PxTriangleMesh.h"
#include "GuTriangleMesh.h"

namespace physx {
	namespace Gu {

	// PT: TODO: replace with Gu::TriangleMesh::getLocalTriangle(...)
	struct TriangleVertexPointers
	{
		static void PX_FORCE_INLINE getTriangleVerts(const TriangleMesh* mesh, PxU32 triangleIndex, PxVec3& v0, PxVec3& v1, PxVec3& v2)
		{
			const PxVec3* verts = mesh->getVerticesFast();
			if(mesh->has16BitIndices())
			{
				const PxU16* tris = reinterpret_cast<const PxU16*>(mesh->getTrianglesFast());
				const PxU16* inds = tris+triangleIndex*3;
				v0 = verts[inds[0]];
				v1 = verts[inds[1]];
				v2 = verts[inds[2]];
			} 
			else 
			{ 
				const PxU32* tris = reinterpret_cast<const PxU32*>(mesh->getTrianglesFast());
				const PxU32* inds = tris+triangleIndex*3;
				v0 = verts[inds[0]];
				v1 = verts[inds[1]];
				v2 = verts[inds[2]];
			} 
		}
	};
} } // physx, Gu

#endif
