#
# Build PhysX (PROJECT not SOLUTION) common
#

ADD_LIBRARY(PhysX ${PHYSX_LIBTYPE}
	${PX_SOURCE_DIR}/NpActor.cpp
	${PX_SOURCE_DIR}/NpAggregate.cpp
	${PX_SOURCE_DIR}/NpArticulation.cpp
	${PX_SOURCE_DIR}/NpArticulationJoint.cpp
	${PX_SOURCE_DIR}/NpArticulationLink.cpp
	${PX_SOURCE_DIR}/NpBatchQuery.cpp
	${PX_SOURCE_DIR}/NpConstraint.cpp
	${PX_SOURCE_DIR}/NpFactory.cpp
	${PX_SOURCE_DIR}/NpMaterial.cpp
	${PX_SOURCE_DIR}/NpMetaData.cpp
	${PX_SOURCE_DIR}/NpPhysics.cpp
	${PX_SOURCE_DIR}/NpPvdSceneQueryCollector.cpp
	${PX_SOURCE_DIR}/NpReadCheck.cpp
	${PX_SOURCE_DIR}/NpRigidDynamic.cpp
	${PX_SOURCE_DIR}/NpRigidStatic.cpp
	${PX_SOURCE_DIR}/NpScene.cpp
	${PX_SOURCE_DIR}/NpSceneQueries.cpp
	${PX_SOURCE_DIR}/NpSerializerAdapter.cpp
	${PX_SOURCE_DIR}/NpShape.cpp
	${PX_SOURCE_DIR}/NpShapeManager.cpp
	${PX_SOURCE_DIR}/NpSpatialIndex.cpp
	${PX_SOURCE_DIR}/NpVolumeCache.cpp
	${PX_SOURCE_DIR}/NpWriteCheck.cpp
	${PX_SOURCE_DIR}/PvdMetaDataPvdBinding.cpp
	${PX_SOURCE_DIR}/PvdPhysicsClient.cpp
	${PX_SOURCE_DIR}/buffering/ScbActor.cpp
	${PX_SOURCE_DIR}/buffering/ScbAggregate.cpp
	${PX_SOURCE_DIR}/buffering/ScbBase.cpp
	${PX_SOURCE_DIR}/buffering/ScbCloth.cpp
	${PX_SOURCE_DIR}/buffering/ScbMetaData.cpp
	${PX_SOURCE_DIR}/buffering/ScbParticleSystem.cpp
	${PX_SOURCE_DIR}/buffering/ScbScene.cpp
	${PX_SOURCE_DIR}/buffering/ScbScenePvdClient.cpp
	${PX_SOURCE_DIR}/buffering/ScbShape.cpp
	${PX_SOURCE_DIR}/cloth/NpCloth.cpp
	${PX_SOURCE_DIR}/cloth/NpClothFabric.cpp
	${PX_SOURCE_DIR}/cloth/NpClothParticleData.cpp

	${PX_SOURCE_DIR}/particles/NpParticleFluid.cpp
	${PX_SOURCE_DIR}/particles/NpParticleSystem.cpp

    ${PHYSX_SOURCE_DIR}/ImmediateMode/src/NpImmediateMode.cpp

	${MD_SOURCE_DIR}/core/src/PxAutoGeneratedMetaDataObjects.cpp
	${MD_SOURCE_DIR}/core/src/PxMetaDataObjects.cpp
	
	${PHYSX_PLATFORM_SRC_FILES}
)

# Target specific compile options


TARGET_INCLUDE_DIRECTORIES(PhysX 
	PRIVATE ${PHYSX_PLATFORM_INCLUDES}
	PRIVATE ${PXSHARED_ROOT_DIR}/include
	PRIVATE ${PXSHARED_ROOT_DIR}/src/foundation/include
	PRIVATE ${PXSHARED_ROOT_DIR}/src/fastxml/include
	PRIVATE ${PXSHARED_ROOT_DIR}/src/pvd/include

	PRIVATE ${PHYSX_ROOT_DIR}/Include
	PRIVATE ${PHYSX_ROOT_DIR}/Include/gpu
	PRIVATE ${PHYSX_ROOT_DIR}/Include/common
	PRIVATE ${PHYSX_ROOT_DIR}/Include/geometry
	PRIVATE ${PHYSX_ROOT_DIR}/Include/pvd
	PRIVATE ${PHYSX_ROOT_DIR}/Include/particles
	PRIVATE ${PHYSX_ROOT_DIR}/Include/cloth
	PRIVATE ${PHYSX_ROOT_DIR}/Include/GeomUtils

	PRIVATE ${PHYSX_SOURCE_DIR}/Common/include
	PRIVATE ${PHYSX_SOURCE_DIR}/Common/src

	PRIVATE ${PHYSX_SOURCE_DIR}/PhysX/src
	PRIVATE ${PHYSX_SOURCE_DIR}/PhysX/src/device
	PRIVATE ${PHYSX_SOURCE_DIR}/PhysX/src/buffering
	PRIVATE ${PHYSX_SOURCE_DIR}/PhysX/src/particles
	PRIVATE ${PHYSX_SOURCE_DIR}/PhysX/src/cloth

	PRIVATE ${PHYSX_SOURCE_DIR}/PhysXGpu/include
	
	PRIVATE ${PHYSX_SOURCE_DIR}/PhysXProfile/include
	PRIVATE ${PHYSX_SOURCE_DIR}/PhysXProfile/src
	
	PRIVATE ${PHYSX_SOURCE_DIR}/GeomUtils/headers
	PRIVATE ${PHYSX_SOURCE_DIR}/GeomUtils/src
	PRIVATE ${PHYSX_SOURCE_DIR}/GeomUtils/src/contact
	PRIVATE ${PHYSX_SOURCE_DIR}/GeomUtils/src/common
	PRIVATE ${PHYSX_SOURCE_DIR}/GeomUtils/src/convex
	PRIVATE ${PHYSX_SOURCE_DIR}/GeomUtils/src/distance
	PRIVATE ${PHYSX_SOURCE_DIR}/GeomUtils/src/sweep
	PRIVATE ${PHYSX_SOURCE_DIR}/GeomUtils/src/gjk
	PRIVATE ${PHYSX_SOURCE_DIR}/GeomUtils/src/intersection
	PRIVATE ${PHYSX_SOURCE_DIR}/GeomUtils/src/mesh
	PRIVATE ${PHYSX_SOURCE_DIR}/GeomUtils/src/hf
	PRIVATE ${PHYSX_SOURCE_DIR}/GeomUtils/src/pcm
	PRIVATE ${PHYSX_SOURCE_DIR}/GeomUtils/src/ccd
	
	PRIVATE ${PHYSX_SOURCE_DIR}/LowLevel/API/include
	PRIVATE ${PHYSX_SOURCE_DIR}/LowLevel/software/include
	PRIVATE ${PHYSX_SOURCE_DIR}/LowLevel/common/include/pipeline

	PRIVATE ${PHYSX_SOURCE_DIR}/LowLevelAABB/include
	
	PRIVATE ${PHYSX_SOURCE_DIR}/LowLevelDynamics/include

	PRIVATE ${PHYSX_SOURCE_DIR}/LowLevelParticles/include
	
	PRIVATE ${PHYSX_SOURCE_DIR}/SimulationController/include
	PRIVATE ${PHYSX_SOURCE_DIR}/SimulationController/src
	PRIVATE ${PHYSX_SOURCE_DIR}/SimulationController/src/particles
	
	PRIVATE ${PHYSX_SOURCE_DIR}/PhysXCooking/src
	PRIVATE ${PHYSX_SOURCE_DIR}/PhysXCooking/src/mesh
	PRIVATE ${PHYSX_SOURCE_DIR}/PhysXCooking/src/convex
	
	PRIVATE ${PHYSX_SOURCE_DIR}/SceneQuery/include
	
	PRIVATE ${PHYSX_SOURCE_DIR}/PhysXMetaData/core/include

    	PRIVATE ${PHYSX_SOURCE_DIR}/ImmediateMode/include
)

TARGET_COMPILE_DEFINITIONS(PhysX 

	# Common to all configurations
	PRIVATE ${PHYSX_COMPILE_DEFS}
)


SET_TARGET_PROPERTIES(PhysX PROPERTIES
	OUTPUT_NAME PhysX3

)

SET_TARGET_PROPERTIES(PhysX PROPERTIES 
	COMPILE_PDB_NAME_DEBUG "PhysX3${CMAKE_DEBUG_POSTFIX}"
	COMPILE_PDB_NAME_CHECKED "PhysX3${CMAKE_CHECKED_POSTFIX}"
	COMPILE_PDB_NAME_PROFILE "PhysX3${CMAKE_PROFILE_POSTFIX}"
	COMPILE_PDB_NAME_RELEASE "PhysX3${CMAKE_RELEASE_POSTFIX}"
)