// Copyright 1998-2017 Epic Games, Inc. All Rights Reserved.
#pragma once

#include "TP_PuzzlePawn.generated.h"

UCLASS(config=Game)
class ATP_PuzzlePawn : public APawn
{
	GENERATED_UCLASS_BODY()

public:

	virtual void Tick(float DeltaSeconds) override;

	virtual void SetupPlayerInputComponent(UInputComponent* PlayerInputComponent) override;

	virtual void CalcCamera(float DeltaTime, struct FMinimalViewInfo& OutResult) override;

protected:
	void OnResetVR();
	void TriggerClick();
	void TraceForBlock(const FVector& Start, const FVector& End, bool bDrawDebugHelpers);

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite)
	class ATP_PuzzleBlock* CurrentBlockFocus;
};
